Index: /BAORadio/libindi/libindi/libs/indibase/basedriver.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/basedriver.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/basedriver.cpp	(revision 642)
@@ -1,2 +1,20 @@
+/*******************************************************************************
+  Copyright(c) 2011 Jasem Mutlaq. All rights reserved.
+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
+*******************************************************************************/
+
 #include <stdlib.h>
 #include <string.h>
@@ -9,13 +27,77 @@
 #include "base64.h"
 
+PropertyContainer::PropertyContainer()
+{
+    pPtr = NULL;
+    pRegistered = false;
+    pDynamic = false;
+    pType = INDI_UNKNOWN;
+}
+
+PropertyContainer::~PropertyContainer()
+{
+    // Only delete properties if they were created dynamically via the buildSkeleton
+    // function. Other drivers are responsible for their own memory allocation.
+    if (pDynamic)
+    {
+        switch (pType)
+        {
+        case INDI_NUMBER:
+         delete ((INumberVectorProperty *) pPtr);
+         break;
+
+        case INDI_TEXT:
+        delete ((ITextVectorProperty *) pPtr);
+        break;
+
+        case INDI_SWITCH:
+        delete ((ISwitchVectorProperty *) pPtr);
+        break;
+
+        case INDI_LIGHT:
+        delete ((ILightVectorProperty *) pPtr);
+        break;
+
+        case INDI_BLOB:
+        delete ((IBLOBVectorProperty *) pPtr);
+        break;
+
+    }
+  }
+}
+
+void PropertyContainer::setProperty(void *p)
+{
+    pRegistered = true;
+    pPtr = p;
+
+}
+
+void PropertyContainer::setType(INDI_TYPE t)
+{
+    pType = t;
+}
+
+void PropertyContainer::setRegistered(bool r)
+{
+   pRegistered = r;
+}
+
+void PropertyContainer::setDynamic(bool d)
+{
+   pDynamic = d;
+}
+
 INDI::BaseDriver::BaseDriver()
 {
     mediator = NULL;
     lp = newLilXML();
+    char indidev[MAXINDIDEVICE];
+    strncpy(indidev, "INDIDEV=", MAXINDIDEVICE);
 
     if (getenv("INDIDEV") != NULL)
     {
-        strncpy(deviceID, getenv("INDIDEV"), MAXINDINAME);
-        putenv("INDIDEV=");
+        strncpy(deviceID, getenv("INDIDEV"), MAXINDIDEVICE);
+        putenv(indidev);
     }
 }
@@ -25,4 +107,9 @@
 {
     delLilXML (lp);
+    while(!pAll.empty())
+    {
+      delete pAll.back();
+      pAll.pop_back();
+    }
 }
 
@@ -31,5 +118,5 @@
     INumberVectorProperty * nvp = NULL;
 
-    nvp = static_cast<INumberVectorProperty *> (getProperty(name, INDI_NUMBER));
+    nvp = static_cast<INumberVectorProperty *> (getProperty(name, PropertyContainer::INDI_NUMBER));
 
     return nvp;
@@ -40,5 +127,5 @@
     ITextVectorProperty * tvp = NULL;
 
-    tvp = static_cast<ITextVectorProperty *> (getProperty(name, INDI_TEXT));
+    tvp = static_cast<ITextVectorProperty *> (getProperty(name, PropertyContainer::INDI_TEXT));
 
     return tvp;
@@ -49,5 +136,5 @@
     ISwitchVectorProperty * svp = NULL;
 
-    svp = static_cast<ISwitchVectorProperty *> (getProperty(name, INDI_SWITCH));
+    svp = static_cast<ISwitchVectorProperty *> (getProperty(name, PropertyContainer::INDI_SWITCH));
 
     return svp;
@@ -58,5 +145,5 @@
     ILightVectorProperty * lvp = NULL;
 
-    lvp = static_cast<ILightVectorProperty *> (getProperty(name, INDI_LIGHT));
+    lvp = static_cast<ILightVectorProperty *> (getProperty(name, PropertyContainer::INDI_LIGHT));
 
     return lvp;
@@ -67,12 +154,16 @@
   IBLOBVectorProperty * bvp = NULL;
 
-  bvp = static_cast<IBLOBVectorProperty *> (getProperty(name, INDI_BLOB));
+  bvp = static_cast<IBLOBVectorProperty *> (getProperty(name, PropertyContainer::INDI_BLOB));
 
   return bvp;
 }
 
-void * INDI::BaseDriver::getProperty(const char *name, INDI_TYPE type)
-{
-    std::map< boost::shared_ptr<void>, INDI_TYPE>::iterator orderi;
+void * INDI::BaseDriver::getProperty(const char *name, PropertyContainer::INDI_TYPE type)
+{
+    PropertyContainer::INDI_TYPE pType;
+    void *pPtr;
+    bool pRegistered = false;
+
+    std::vector<PropertyContainer *>::iterator orderi;
 
     INumberVectorProperty *nvp;
@@ -84,33 +175,53 @@
     for (orderi = pAll.begin(); orderi != pAll.end(); orderi++)
     {
-        if (type != INDI_UNKNOWN &&  orderi->second != type)
+        pType       = (*orderi)->getType();
+        pPtr        = (*orderi)->getProperty();
+        pRegistered = (*orderi)->getRegistered();
+
+        if (type != PropertyContainer::INDI_UNKNOWN && pType != type)
             continue;
 
-        switch (orderi->second)
-        {
-        case INDI_NUMBER:
-            nvp = static_cast<INumberVectorProperty *>((orderi->first).get());
-            if (!strcmp(name, nvp->name))
-                return (orderi->first).get();
-             break;
-        case INDI_TEXT:
-             tvp = static_cast<ITextVectorProperty *>((orderi->first).get());
-             if (!strcmp(name, tvp->name))
-                return (orderi->first).get();
-             break;
-        case INDI_SWITCH:
-             svp = static_cast<ISwitchVectorProperty *>((orderi->first).get());
-             if (!strcmp(name, svp->name))
-                 return (orderi->first).get();
-             break;
-        case INDI_LIGHT:
-             lvp = static_cast<ILightVectorProperty *>((orderi->first).get());
-             if (!strcmp(name, lvp->name))
-                 return (orderi->first).get();
-             break;
-        case INDI_BLOB:
-             bvp = static_cast<IBLOBVectorProperty *>((orderi->first).get());
-             if (!strcmp(name, bvp->name))
-                 return (orderi->first).get();
+        switch (pType)
+        {
+        case PropertyContainer::INDI_NUMBER:
+            nvp = static_cast<INumberVectorProperty *>(pPtr);
+            if (nvp == NULL)
+                continue;
+
+            if (!strcmp(name, nvp->name) && pRegistered)
+                return pPtr;
+             break;
+        case PropertyContainer::INDI_TEXT:
+             tvp = static_cast<ITextVectorProperty *>(pPtr);
+             if (tvp == NULL)
+                 continue;
+
+             if (!strcmp(name, tvp->name)  && pRegistered)
+                return pPtr;
+             break;
+        case PropertyContainer::INDI_SWITCH:
+             svp = static_cast<ISwitchVectorProperty *>(pPtr);
+             if (svp == NULL)
+                 continue;
+
+             //IDLog("Switch %s and aux value is now %d\n", svp->name, regStatus );
+             if (!strcmp(name, svp->name) && pRegistered)
+                 return pPtr;
+             break;
+        case PropertyContainer::INDI_LIGHT:
+             lvp = static_cast<ILightVectorProperty *>(pPtr);
+             if (lvp == NULL)
+                 continue;
+
+             if (!strcmp(name, lvp->name)  && pRegistered)
+                 return pPtr;
+             break;
+        case PropertyContainer::INDI_BLOB:
+             bvp = static_cast<IBLOBVectorProperty *>(pPtr);
+             if (bvp == NULL)
+                 continue;
+
+             if (!strcmp(name, bvp->name) && pRegistered)
+                 return pPtr;
              break;
         }
@@ -121,7 +232,11 @@
 }
 
-int INDI::BaseDriver::removeProperty(const char *name)
-{
-    std::map< boost::shared_ptr<void>, INDI_TYPE>::iterator orderi;
+PropertyContainer * INDI::BaseDriver::getContainer(const char *name, PropertyContainer::INDI_TYPE type)
+{
+    PropertyContainer::INDI_TYPE pType;
+    void *pPtr;
+    bool pRegistered = false;
+
+    std::vector<PropertyContainer *>::iterator orderi;
 
     INumberVectorProperty *nvp;
@@ -133,43 +248,118 @@
     for (orderi = pAll.begin(); orderi != pAll.end(); orderi++)
     {
-        switch (orderi->second)
-        {
-        case INDI_NUMBER:
-            nvp = static_cast<INumberVectorProperty *>((orderi->first).get());
+        pType       = (*orderi)->getType();
+        pPtr        = (*orderi)->getProperty();
+        pRegistered = (*orderi)->getRegistered();
+
+        if (type != PropertyContainer::INDI_UNKNOWN && pType != type)
+            continue;
+
+        switch (pType)
+        {
+        case PropertyContainer::INDI_NUMBER:
+            nvp = static_cast<INumberVectorProperty *>(pPtr);
+            if (nvp == NULL)
+                continue;
+
+            if (!strcmp(name, nvp->name) && pRegistered)
+                return *orderi;
+             break;
+        case PropertyContainer::INDI_TEXT:
+             tvp = static_cast<ITextVectorProperty *>(pPtr);
+             if (tvp == NULL)
+                 continue;
+
+             if (!strcmp(name, tvp->name)  && pRegistered)
+                return *orderi;
+             break;
+        case PropertyContainer::INDI_SWITCH:
+             svp = static_cast<ISwitchVectorProperty *>(pPtr);
+             if (svp == NULL)
+                 continue;
+
+             //IDLog("Switch %s and aux value is now %d\n", svp->name, regStatus );
+             if (!strcmp(name, svp->name) && pRegistered)
+                 return *orderi;
+             break;
+        case PropertyContainer::INDI_LIGHT:
+             lvp = static_cast<ILightVectorProperty *>(pPtr);
+             if (lvp == NULL)
+                 continue;
+
+             if (!strcmp(name, lvp->name)  && pRegistered)
+                 return *orderi;
+             break;
+        case PropertyContainer::INDI_BLOB:
+             bvp = static_cast<IBLOBVectorProperty *>(pPtr);
+             if (bvp == NULL)
+                 continue;
+
+             if (!strcmp(name, bvp->name) && pRegistered)
+                 return *orderi;
+             break;
+        }
+
+    }
+
+    return NULL;
+}
+
+int INDI::BaseDriver::removeProperty(const char *name)
+{    
+    std::vector<PropertyContainer *>::iterator orderi;
+
+    PropertyContainer::INDI_TYPE pType;
+    void *pPtr;
+
+    INumberVectorProperty *nvp;
+    ITextVectorProperty *tvp;
+    ISwitchVectorProperty *svp;
+    ILightVectorProperty *lvp;
+    IBLOBVectorProperty *bvp;
+
+    for (orderi = pAll.begin(); orderi != pAll.end(); orderi++)
+    {
+        pType       = (*orderi)->getType();
+        pPtr        = (*orderi)->getProperty();
+
+        switch (pType)
+        {
+        case PropertyContainer::INDI_NUMBER:
+            nvp = static_cast<INumberVectorProperty *>(pPtr);
             if (!strcmp(name, nvp->name))
             {
-                 pAll.erase(orderi);
+                (*orderi)->setRegistered(false);
                  return 0;
              }
              break;
-        case INDI_TEXT:
-             tvp = static_cast<ITextVectorProperty *>((orderi->first).get());
+        case PropertyContainer::INDI_TEXT:
+             tvp = static_cast<ITextVectorProperty *>(pPtr);
              if (!strcmp(name, tvp->name))
              {
-                  pAll.erase(orderi);
+                  (*orderi)->setRegistered(false);
                   return 0;
               }
              break;
-        case INDI_SWITCH:
-             svp = static_cast<ISwitchVectorProperty *>((orderi->first).get());
+        case PropertyContainer::INDI_SWITCH:
+             svp = static_cast<ISwitchVectorProperty *>(pPtr);
              if (!strcmp(name, svp->name))
              {
-                  pAll.erase(orderi);
+                 (*orderi)->setRegistered(false);
                   return 0;
               }
              break;
-        case INDI_LIGHT:
-             lvp = static_cast<ILightVectorProperty *>((orderi->first).get());
+        case PropertyContainer::INDI_LIGHT:
+             lvp = static_cast<ILightVectorProperty *>(pPtr);
              if (!strcmp(name, lvp->name))
              {
-                  pAll.erase(orderi);
+                 (*orderi)->setRegistered(false);
                   return 0;
               }
              break;
-        case INDI_BLOB:
-             bvp = static_cast<IBLOBVectorProperty *>((orderi->first).get());
+        case PropertyContainer::INDI_BLOB:
+             bvp = static_cast<IBLOBVectorProperty *>(pPtr);
              if (!strcmp(name, bvp->name))
              {
-                  pAll.erase(orderi);
+                 (*orderi)->setRegistered(false);
                   return 0;
               }
@@ -215,8 +405,6 @@
     IPerm perm;
     IPState state;
-    ISRule rule;
     XMLEle *ep = NULL;
     char *rtag, *rname, *rdev;
-    //INDI_TYPE type;
     double timeout=0;
 
@@ -258,8 +446,7 @@
     if (!strcmp (rtag, "defNumberVector"))
     {
-
-        numberPtr nvp(new INumberVectorProperty);
-        //INumberVectorProperty *nvp = new INumberVectorProperty;
-        //INumberVectorProperty *nvp = (INumberVectorProperty *) malloc(sizeof(INumberVectorProperty));
+        PropertyContainer *indiProp = new PropertyContainer();
+        INumberVectorProperty *nvp = new INumberVectorProperty;
+
         INumber *np = NULL;
         int n=0;
@@ -281,5 +468,5 @@
             np = (INumber *) realloc(np, (n+1) * sizeof(INumber));
 
-            np[n].nvp = nvp.get();
+            np[n].nvp = nvp;
 
             XMLAtt *na = findXMLAtt (ep, "name");
@@ -320,9 +507,11 @@
         nvp->nnp = n;
         nvp->np  = np;
-        //orderPtr o(new pOrder);
-        //o->p = &nvp;
-        //o->type = INDI_NUMBER;
-        //pAll.push_back(o);
-        pAll[nvp] = INDI_NUMBER;
+
+        indiProp->setProperty(nvp);
+        indiProp->setDynamic(true);
+        indiProp->setType(PropertyContainer::INDI_NUMBER);
+
+        pAll.push_back(indiProp);
+
         //IDLog("Adding number property %s to list.\n", nvp->name);
         if (mediator)
@@ -334,7 +523,7 @@
   else if (!strcmp (rtag, "defSwitchVector"))
         {
-            switchPtr svp(new ISwitchVectorProperty);
-            //ISwitchVectorProperty *svp = new ISwitchVectorProperty;
-            //ISwitchVectorProperty *svp = (ISwitchVectorProperty *) malloc(sizeof(ISwitchVectorProperty));
+            PropertyContainer *indiProp = new PropertyContainer();
+            ISwitchVectorProperty *svp = new ISwitchVectorProperty;
+
             ISwitch *sp = NULL;
             int n=0;
@@ -360,5 +549,5 @@
                 sp = (ISwitch *) realloc(sp, (n+1) * sizeof(ISwitch));
 
-                sp[n].svp = svp.get();
+                sp[n].svp = svp;
 
                 XMLAtt *na = findXMLAtt (ep, "name");
@@ -380,9 +569,10 @@
             svp->nsp = n;
             svp->sp  = sp;
-            //orderPtr o(new pOrder);
-            //o->p = &svp;
-            //o->type = INDI_SWITCH;
-            //pAll.push_back(o);
-            pAll[svp] = INDI_SWITCH;
+
+            indiProp->setProperty(svp);
+            indiProp->setDynamic(true);
+            indiProp->setType(PropertyContainer::INDI_SWITCH);
+
+            pAll.push_back(indiProp);
             //IDLog("Adding Switch property %s to list.\n", svp->name);
             if (mediator)
@@ -396,7 +586,6 @@
     {
 
-        //ITextVectorProperty *tvp = new ITextVectorProperty;
-        //ITextVectorProperty *tvp = (ITextVectorProperty *) malloc(sizeof(ITextVectorProperty));
-        textPtr tvp(new ITextVectorProperty);
+        PropertyContainer *indiProp = new PropertyContainer();
+        ITextVectorProperty *tvp = new ITextVectorProperty;
         IText *tp = NULL;
         int n=0;
@@ -418,5 +607,5 @@
             tp = (IText *) realloc(tp, (n+1) * sizeof(IText));
 
-            tp[n].tvp = tvp.get();
+            tp[n].tvp = tvp;
 
             XMLAtt *na = findXMLAtt (ep, "name");
@@ -439,9 +628,10 @@
         tvp->ntp = n;
         tvp->tp  = tp;
-        //orderPtr o(new pOrder);
-        //o->p = &tvp;
-        //o->type = INDI_TEXT;
-        //pAll.push_back(o);
-        pAll[tvp] = INDI_TEXT;
+
+        indiProp->setProperty(tvp);
+        indiProp->setDynamic(true);
+        indiProp->setType(PropertyContainer::INDI_TEXT);
+
+        pAll.push_back(indiProp);
         //IDLog("Adding Text property %s to list.\n", tvp->name);
         if (mediator)
@@ -454,7 +644,6 @@
     {
 
-        //ILightVectorProperty *lvp = new ILightVectorProperty;
-        //ILightVectorProperty *lvp = (ILightVectorProperty *) malloc(sizeof(ILightVectorProperty));
-        lightPtr lvp(new ILightVectorProperty);
+        PropertyContainer *indiProp = new PropertyContainer();
+        ILightVectorProperty *lvp = new ILightVectorProperty;
         ILight *lp = NULL;
         int n=0;
@@ -474,5 +663,5 @@
             lp = (ILight *) realloc(lp, (n+1) * sizeof(ILight));
 
-            lp[n].lvp = lvp.get();
+            lp[n].lvp = lvp;
 
             XMLAtt *na = findXMLAtt (ep, "name");
@@ -495,9 +684,11 @@
         lvp->nlp = n;
         lvp->lp  = lp;
-        //orderPtr o(new pOrder);
-        //o->p = &lvp;
-        //o->type = INDI_LIGHT;
-        //pAll.push_back(o);
-        pAll[lvp] = INDI_LIGHT;
+
+        indiProp->setProperty(lvp);
+        indiProp->setDynamic(true);
+        indiProp->setType(PropertyContainer::INDI_LIGHT);
+
+        pAll.push_back(indiProp);
+
         //IDLog("Adding Light property %s to list.\n", lvp->name);
         if (mediator)
@@ -509,8 +700,6 @@
 else if (!strcmp (rtag, "defBLOBVector"))
     {
-
-        //IBLOBVectorProperty *bvp = new IBLOBVectorProperty;
-        //IBLOBVectorProperty *bvp = (IBLOBVectorProperty *) malloc(sizeof(IBLOBVectorProperty));
-        blobPtr bvp(new IBLOBVectorProperty);
+        PropertyContainer *indiProp = new PropertyContainer();
+        IBLOBVectorProperty *bvp = new IBLOBVectorProperty;
         IBLOB *bp = NULL;
         int n=0;
@@ -530,5 +719,5 @@
             bp = (IBLOB *) realloc(bp, (n+1) * sizeof(IBLOB));
 
-            bp[n].bvp = bvp.get();
+            bp[n].bvp = bvp;
 
             XMLAtt *na = findXMLAtt (ep, "name");
@@ -560,9 +749,10 @@
         bvp->nbp = n;
         bvp->bp  = bp;
-        //orderPtr o(new pOrder);
-        //o->p = &bvp;
-        //o->type = INDI_BLOB;
-        //pAll.push_back(o);
-        pAll[bvp] = INDI_BLOB;
+
+        indiProp->setProperty(bvp);
+        indiProp->setDynamic(true);
+        indiProp->setType(PropertyContainer::INDI_BLOB);
+
+        pAll.push_back(indiProp);
         //IDLog("Adding BLOB property %s to list.\n", bvp->name);
         if (mediator)
@@ -913,64 +1103,93 @@
 }
 
-void INDI::BaseDriver::registerProperty(void *p, INDI_TYPE type)
-{
-
-
-    if (type == INDI_NUMBER)
+void INDI::BaseDriver::registerProperty(void *p, PropertyContainer::INDI_TYPE type)
+{
+    PropertyContainer *pContainer;
+
+    if (type == PropertyContainer::INDI_NUMBER)
     {
         INumberVectorProperty *nvp = static_cast<INumberVectorProperty *> (p);
-        if (getProperty(nvp->name, INDI_NUMBER) != NULL)
+        if ( (pContainer = getContainer(nvp->name, PropertyContainer::INDI_NUMBER)) != NULL)
+        {
+            pContainer->setRegistered(true);
             return;
-
-        numberPtr ovp(nvp);
-
-        pAll[ovp] = INDI_NUMBER;
-    }
-    else if (type == INDI_TEXT)
+        }
+
+        pContainer = new PropertyContainer();
+        pContainer->setProperty(p);
+        pContainer->setType(type);
+
+        pAll.push_back(pContainer);
+
+    }
+    else if (type == PropertyContainer::INDI_TEXT)
     {
        ITextVectorProperty *tvp = static_cast<ITextVectorProperty *> (p);
-       if (getProperty(tvp->name, INDI_TEXT) != NULL)
+
+       if ( (pContainer = getContainer(tvp->name, PropertyContainer::INDI_TEXT)) != NULL)
+       {
+           pContainer->setRegistered(true);
            return;
-
-       textPtr ovp(tvp);
-       //o->p = &ovp;
-
-       pAll[ovp] = INDI_TEXT;
+       }
+
+       pContainer = new PropertyContainer();
+       pContainer->setProperty(p);
+       pContainer->setType(type);
+
+       pAll.push_back(pContainer);
+
+
    }
-    else if (type == INDI_SWITCH)
+    else if (type == PropertyContainer::INDI_SWITCH)
     {
        ISwitchVectorProperty *svp = static_cast<ISwitchVectorProperty *> (p);
-       if (getProperty(svp->name, INDI_SWITCH) != NULL)
+
+       if ( (pContainer = getContainer(svp->name, PropertyContainer::INDI_SWITCH)) != NULL)
+       {
+           pContainer->setRegistered(true);
            return;
-
-       switchPtr ovp(svp);
-       //o->p = &ovp;
-
-       IDLog("Registering switch %s\n", svp->name);
-
-       pAll[ovp] = INDI_SWITCH;
-    }
-    else if (type == INDI_LIGHT)
+       }
+
+       pContainer = new PropertyContainer();
+       pContainer->setProperty(p);
+       pContainer->setType(type);
+
+       pAll.push_back(pContainer);
+
+    }
+    else if (type == PropertyContainer::INDI_LIGHT)
     {
        ILightVectorProperty *lvp = static_cast<ILightVectorProperty *> (p);
-       if (getProperty(lvp->name, INDI_LIGHT) != NULL)
+
+       if ( (pContainer = getContainer(lvp->name, PropertyContainer::INDI_LIGHT)) != NULL)
+       {
+           pContainer->setRegistered(true);
            return;
-
-       lightPtr ovp(lvp);
-       //o->p = &ovp;
-       pAll[ovp] = INDI_LIGHT;
+       }
+
+       pContainer = new PropertyContainer();
+       pContainer->setProperty(p);
+       pContainer->setType(type);
+
+       pAll.push_back(pContainer);
    }
-    else if (type == INDI_BLOB)
+    else if (type == PropertyContainer::INDI_BLOB)
     {
        IBLOBVectorProperty *bvp = static_cast<IBLOBVectorProperty *> (p);
-       if (getProperty(bvp->name, INDI_BLOB) != NULL)
+
+       if ( (pContainer = getContainer(bvp->name, PropertyContainer::INDI_BLOB)) != NULL)
+       {
+           pContainer->setRegistered(true);
            return;
-
-       blobPtr ovp(bvp);
-       //o->p = &ovp;
-
-       pAll[ovp] = INDI_BLOB;
-    }
-
-}
-
+       }
+
+       pContainer = new PropertyContainer();
+       pContainer->setProperty(p);
+       pContainer->setType(type);
+
+       pAll.push_back(pContainer);
+
+    }
+
+}
+
Index: /BAORadio/libindi/libindi/libs/indibase/basedriver.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/basedriver.h	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/basedriver.h	(revision 642)
@@ -1,7 +1,24 @@
+/*******************************************************************************
+  Copyright(c) 2011 Jasem Mutlaq. All rights reserved.
+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
+*******************************************************************************/
+
 #ifndef INDIBASEDRIVER_H
 #define INDIBASEDRIVER_H
 
-#include <boost/shared_ptr.hpp>
-#include <map>
+#include <vector>
 #include <string>
 
@@ -11,4 +28,38 @@
 
 #define MAXRBUF 2048
+
+class PropertyContainer
+{
+public:
+    PropertyContainer();
+    ~PropertyContainer();
+
+    /*! INDI property type */
+    typedef enum
+    {
+        INDI_NUMBER, /*!< INumberVectorProperty. */
+        INDI_SWITCH, /*!< ISwitchVectorProperty. */
+        INDI_TEXT,   /*!< ITextVectorProperty. */
+        INDI_LIGHT,  /*!< ILightVectorProperty. */
+        INDI_BLOB,    /*!< IBLOBVectorProperty. */
+        INDI_UNKNOWN
+    } INDI_TYPE;
+
+    void setProperty(void *);
+    void setType(INDI_TYPE t);
+    void setRegistered(bool r);
+    void setDynamic(bool d);
+
+    void *getProperty() { return pPtr; }
+    INDI_TYPE getType() { return pType; }
+    bool getRegistered() { return pRegistered; }
+    bool getDynamic() { return pDynamic; }
+
+private:
+    void *pPtr;
+    INDI_TYPE pType;
+    bool pRegistered;
+    bool pDynamic;
+};
 
 /**
@@ -37,15 +88,4 @@
     };
 
-    /*! INDI property type */
-    typedef enum
-    {
-        INDI_NUMBER, /*!< INumberVectorProperty. */
-        INDI_SWITCH, /*!< ISwitchVectorProperty. */
-        INDI_TEXT,   /*!< ITextVectorProperty. */
-        INDI_LIGHT,  /*!< ILightVectorProperty. */
-        INDI_BLOB,    /*!< IBLOBVectorProperty. */
-        INDI_UNKNOWN
-    } INDI_TYPE;
-
     /** \return Return vector number property given its name */
     INumberVectorProperty * getNumber(const char *name);
@@ -59,5 +99,5 @@
     IBLOBVectorProperty * getBLOB(const char *name);
 
-    void registerProperty(void *p, INDI_TYPE type);
+    void registerProperty(void *p, PropertyContainer::INDI_TYPE type);
 
     /** \brief Remove a property
@@ -77,5 +117,7 @@
 
     */
-    void * getProperty(const char *name, INDI_TYPE type = INDI_UNKNOWN);
+    void * getProperty(const char *name, PropertyContainer::INDI_TYPE type = PropertyContainer::INDI_UNKNOWN);
+
+    PropertyContainer * getContainer(const char *name, PropertyContainer::INDI_TYPE type = PropertyContainer::INDI_UNKNOWN);
 
     /** \brief Build driver properties from a skeleton file.
@@ -133,15 +175,10 @@
     int setBLOB(IBLOBVectorProperty *pp, XMLEle * root, char * errmsg);
 
-    char deviceID[MAXINDINAME];
-
-    typedef boost::shared_ptr<INumberVectorProperty> numberPtr;
-    typedef boost::shared_ptr<ITextVectorProperty> textPtr;
-    typedef boost::shared_ptr<ISwitchVectorProperty> switchPtr;
-    typedef boost::shared_ptr<ILightVectorProperty> lightPtr;
-    typedef boost::shared_ptr<IBLOBVectorProperty> blobPtr;
 
 private:
 
-    std::map< boost::shared_ptr<void>, INDI_TYPE> pAll;
+    char deviceID[MAXINDINAME];
+
+    std::vector<PropertyContainer *> pAll;
 
     LilXML *lp;
